// Output generated from file: D:/fractal/Fragmentarium/Output/CristJRoger/pleiniancrossm/pleiniancm1.frag
// Created: Wed Nov 16 16:26:20 2016
// Output generated from file: D:/fractal/Fragmentarium/Output/pleiniancrossm crist/PleinianCM.frag
// Created: Wed Oct 26 16:29:09 2016
// Output generated from file: D:/frag/DE-parts/PleinianCM.frag
// Created:  5.  13:09:20 2016

//Provided by Crist-JRoger
// Made by Knighty, see this thread:
// http://www.fractalforums.com/3d-fractal-generation/fragmentarium-an-ide-for-exploring-3d-fractals-and-other-systems-on-the-gpu/msg32270/#msg32270

#define providesInit
#define USE_INF_NORM
#define KN_VOLUMETRIC
#define USE_EIFFIE_SHADOW
#define USE_IQ_CLOUDS
#define MULTI_SAMPLE_AO
#define AUTOFOCUS
#include "MathUtils.frag"
#include "DE-Kn2cr11.frag"





#group PseudoKleinian

// Maximum iterations
uniform int MI; slider[0,5,100]
uniform float Size; slider[0,1,20]
uniform vec3 CSize; slider[(0,0,0),(1,1,1),(2,2,2)]
uniform vec3 C; slider[(-2,-2,-2),(0,0,0),(2,2,2)]
uniform float TThickness; slider[0,0.01,2]
uniform float DEoffset; slider[-0.01,0,0.01]
uniform vec3 Offset; slider[(-1,-1,-1),(0,0,0),(1,1,1)]

uniform int Iterations;  slider[0,3,100]
uniform float Gap; slider[0.,1.,10.]
uniform bool KIFS; checkbox[false]
uniform bool AbsZ; checkbox[false]

uniform vec3 Rot1; slider[(-180,-180,-180),(0,0,0),(180,180,180)]
uniform vec3 Rot2; slider[(-180,-180,-180),(0,0,0),(180,180,180)]
uniform vec3 Rot3; slider[(-180,-180,-180),(0,0,0),(180,180,180)]

mat3 fracRotation1;
mat3 fracRotation2;
mat3 fracRotation3;

void init() {
	fracRotation1 =rotationMatrixXYZ(vec3(Rot1.x,0.0,0.0))*rotationMatrixXYZ(vec3(0.0,Rot1.y,0.0))*rotationMatrixXYZ(vec3(0.0,0.0,Rot1.z));
	fracRotation2 =rotationMatrixXYZ(vec3(Rot2.x,0.0,0.0))*rotationMatrixXYZ(vec3(0.0,Rot2.y,0.0))*rotationMatrixXYZ(vec3(0.0,0.0,Rot2.z));
	fracRotation3 =rotationMatrixXYZ(vec3(Rot3.x,0.0,0.0))*rotationMatrixXYZ(vec3(0.0,Rot3.y,0.0))*rotationMatrixXYZ(vec3(0.0,0.0,Rot3.z));
}

float baseshape(vec3 p, float s){
	p.yz=abs(p.yz);   
	float t = 2. * max(0., dot(p.xy, vec2(-sqrt(3.) * 0.5, 0.5)) );
      p.xy -= t*vec2(-sqrt(3.),1.)*0.5;
	p.y=abs(p.y);
	if(p.y>p.z) p.yz=p.zy; 
	p-=s*vec3(0.5*sqrt(3.),1.5,1.5);
	if(AbsZ) p.z=abs(p.z);
	if(p.z>p.x){p.xz=p.zx;}
	if(p.x<0.) return p.x;
	p.yz=max(vec2(0.),p.yz);

	return length(p);
}

float CrossMengerTrick(vec3 p){//use Msltoe's method. Gives correct result but the DE is discontinuous
	float dd=1.;
	for(int i=0; i<Iterations;i++){
		p=fracRotation3*p;
		p.yz=abs(p.yz); 
		float t = 2. * max(0., dot(p.xy, vec2(-sqrt(3.) * 0.5, 0.5)) );
		p.xy -= t*vec2(-sqrt(3.),1.)*0.5;
		p.y=abs(p.y);

		p.x-=sqrt(3.)*0.5;
      
		//Choose nearest corner/edge --> to get translation symmetry
		float dy=0., dz=0.;
		if(p.y>0.5 && p.z>0.5){dy=1.5; dz=1.5;}
		else if((p.y-1.5)*(p.y-1.5)+p.z*p.z<p.y*p.y+(p.z-1.5)*(p.z-1.5)) dy=1.5;
		else dz=1.5;
      
		p.y-=dy; p.z-=dz; 
		
		p=fracRotation1*p;

		p*=3.;
		dd*=1./3.;
		p.y+=dy; p.z+=dz;
      
		p.x+=sqrt(3.)*0.5;

		p=fracRotation2*p;
		orbitTrap = min(orbitTrap, abs(vec4(p.xyz,dot(p,p))));
	}
	return dd*baseshape(p,Gap);
}


float CrossMengerKIFS(vec3 p){//Pure KIFS... almost correct
	float dd=1.;
	for(int i=0; i<Iterations;i++){
	p=fracRotation1*p;
		p.yz=abs(p.yz); 
		float t = 2. * max(0., dot(p.xy, vec2(-sqrt(3.) * 0.5, 0.5)) );
		p.xy -= t*vec2(-sqrt(3.),1.)*0.5;
		p.y=abs(p.y);
		
		if(p.y>p.z) p.yz=p.zy;
		p.y=abs(p.y-0.5)+0.5; 
		p-=vec3(0.5*sqrt(3.),1.5,1.5);
		
		p*=3.;
		dd*=1./3.;
		p+=vec3(0.5*sqrt(3.),1.5,1.5);
		p=fracRotation2*p;
		orbitTrap = min(orbitTrap, abs(vec4(p.xyz,dot(p,p))));
	}
	return dd*baseshape(p,Gap);
}



float Thing2(vec3 p){
//Just scale=1 Julia box
	float DEfactor=1.;
   	vec3 ap=p+1.;
	for(int i=0;i<MI && ap!=p;i++){
		ap=p;
		p=2.*clamp(p, -CSize, CSize)-p;
     		float r2=dot(p,p);
		orbitTrap = min(orbitTrap, abs(vec4(p,r2)));
		float k=max(Size/r2,1.);
		p*=k;DEfactor*=k;
      		p+=C;
		orbitTrap = min(orbitTrap, abs(vec4(p,dot(p,p))));
	}
	//Call basic shape and scale its DE
	if(KIFS) 	return abs(0.5*CrossMengerKIFS(p*Offset)/DEfactor-DEoffset);
	
	return abs(0.5*CrossMengerTrick(p*Offset)/DEfactor-DEoffset);
	
	//Alternative shape
	//return abs(0.5*RoundBox(p, vec3(1.,1.,1.), 1.0)/DEfactor-DEoffset);
	//Just a plane
	//return abs(0.5*abs(p.z-Offset.z)/DEfactor-DEoffset);
}

float DE(vec3 p){
	return  Thing2(p);//RoundBox(p, CSize, Offset);
}
































































#preset Default
FOV = 0.4878
Eye = -1.571849,-1.512748,2.183094
Target = -0.5401368,-3.639158,0.0821516
Up = 0.3436547,-0.5703692,0.7460423
AutoFocus = false
Gamma = 1.1
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 1.2
DepthToAlpha = true
Detail = -3.218573
FudgeFactor = 0.3434936
Dither = 0.33333
NormalBackStep = 1.8333 NotLocked
CamLight = 1,0.9372549,0.827451,0.1549296
BaseColor = 0.5098039,0.4823529,0.4235294
OrbitStrength = 0.3681063
X = 0.5,0.6,0.6,1
Y = 1,0.6,0,0.37864
Z = 0.8,0.78,1,0.7854807
R = 0.4,0.7,1,0.0508475
BackgroundColor = 0.1686275,0.4117647,0.5647059
GradientBackground = 0
CycleColors = false
Cycles = 0.1
EnableFloor = true NotLocked
FloorNormal = 0.0449827,0,1
FloorHeight = 0.6846951
FloorColor = 0.3921569,0.6156863,0.3333333
AutoFocus = false
UpLock = false
FocalPlane = 2.284924
Aperture = 0.014531
InFocusAWidth = 0.9373315
DofCorrect = true
ApertureNbrSides = 7
ApertureRot = 0
ApStarShaped = false
Bloom = false
BloomIntensity = 0.9015421
BloomPow = 5.616279
BloomTaps = 31
BloomStrong = 14.12972
RefineSteps = 1
MaxRaySteps = 600
MaxDistance = 4
DetailAO = -1.00002
coneApertureAO = 0.8063754
maxIterAO = 83
FudgeAO = 0.8029445
AO_ambient = 1.73763
AO_camlight = 1.603687
AO_pointlight = 1.534183
AoCorrect = 0.8976109
Specular = 1.582864
SpecularExp = 100
AmbiantLight = 1,0.9372549,0.827451,1.508046
Reflection = 0.454902,0.454902,0.454902
ReflectionsNumber = 2
SpotGlow = true
SpotLight = 0.8352941,0.6392157,0.427451,4.861612
LightPos = -1.365741,-3.773148,1.342593
LightSize = 0
LightFallOff = 0.2
LightGlowRad = 0.8775029
LightGlowExp = 0.7705882
HardShadow = 1
ShadowSoft = 0
ShadowBlur = 0
perf = false
SSS = false
sss1 = 0.1
sss2 = 0.5
HF_Fallof = 0.6391013
HF_Const = 0.3348281
HF_Intensity = 0.1220657
HF_Dir = 0,0.8372294,-0.0961039
HF_Offset = 1.311475
HF_Color = 0.4588235,0.6,0.6235294,1.415935
HF_Scatter = 3.442623
HF_Anisotropy = 0,0.08627451,0.1843137
HF_FogIter = 2
HF_CastShadow = true
EnCloudsDir = true NotLocked
Clouds_Dir = 0.3899884,-0.8160652,0.0663562 NotLocked
CloudScale = 1 NotLocked
CloudFlatness = 0 NotLocked
CloudTops = 1 NotLocked
CloudBase = 1.124528 NotLocked
CloudDensity = 0.6921017 NotLocked
CloudRoughness = 1.938697 NotLocked
CloudContrast = 1 NotLocked
CloudColor = 0.65,0.68,0.7 NotLocked
CloudColor2 = 0.07,0.17,0.24 NotLocked
SunLightColor = 0.7,0.5,0.3 NotLocked
Cloudvar1 = 1.040462 NotLocked
Cloudvar2 = 6.949942 NotLocked
CloudIter = 3 NotLocked
CloudBgMix = 1 NotLocked
MI = 63
Size = 3.509561
CSize = 1.135135,1.867117,1.765766
C = 0.0169492,-1.663344,-0.0110742
TThickness = 0
DEoffset = 0
Offset = -0.4896194,0.1214708,1
Iterations = 8
Gap = 1.226097
KIFS = true
AbsZ = true
Rot1 = 0.1466992,-63.52078,36.82286
Rot2 = 13.8456,0,29.41714
Rot3 = 0,0,0
#endpreset

